SystemOrganization addCategory: #'OpenCourses-Tests'!
SystemOrganization addCategory: #OpenCourses!

WAComponent subclass: #OcLoginComponent
	instanceVariableNames: 'password messageComponent loginID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:09'!
applicationName 
	^ OcLibrary applicationName.
	
	! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 23:18'!
initialize 

	super initialize.
	self messageComponent: OcMessageComponent new.  ! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:16'!
loginFailed

	self messageComponent errorMessage: 'Login failed.'.! !

!OcLoginComponent methodsFor: 'accessing' stamp: 'cmb 6/28/2013 11:04'!
loginID
	^ loginID! !

!OcLoginComponent methodsFor: 'accessing' stamp: 'cmb 6/28/2013 11:04'!
loginID: anObject
	loginID := anObject! !

!OcLoginComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:31'!
messageComponent
	^ messageComponent! !

!OcLoginComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:31'!
messageComponent: anObject
	messageComponent := anObject! !

!OcLoginComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:12'!
password
	^ password! !

!OcLoginComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:12'!
password: anObject
	password := anObject! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:17'!
registerUser
 
	self answer: #registerUser.! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:13'!
renderContentOn: html
	html div
 	class: 'generic';
 		with: [
  			html
   			heading: self applicationName;
   			render: self messageComponent;
   			text: 'Please login with e-mail and password:';
   			form: [
    				self
     					renderTextInputOn: html;
     					renderPasswordInputOn: html;
     					renderLoginButtonOn: html;
     					renderSignUpAnchorOn: html]].! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:15'!
renderLoginButtonOn: html

	html submitButton
  		callback: [self validateLogin];
  		text: 'Login'.! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:35'!
renderPasswordInputOn: html

	html passwordInput
  		callback: [:value | self password: (OcUser hashPassword: value)];
  		value: ''.! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:15'!
renderSignUpAnchorOn: html

	html paragraph with: [html anchor
  		callback: [self registerUser];
  		with: [html text: 'Sign up for the ', self applicationName]].! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 11:05'!
renderTextInputOn: html
	html textInput
  		on: #loginID of: self;
  		value: ''.
 	html space.! !

!OcLoginComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 11:06'!
validateLogin

	| user |
 	user := self session findUser: self loginID email: self loginID.
 	(user notNil and: [user password = self password])
  		ifTrue: [self answer: user]
  		ifFalse: [self loginFailed].! !

WAComponent subclass: #OcMainComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcMainComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 15:56'!
renderContentOn: html
 
	html div
  		class: 'generic';
  			with:[
				html anchor
					callback: [self session logout. self answer: true];
					with: 'Logoff'.
   			html heading: 'OpenCourses'.
				html break.
   			html div
    				class: 'menu';
					id: 'menu';
    				with: OcMenuComponent new.
   			html div
    				class: 'list';
    				id: 'list';
    				with: OcWorkspaceComponent new.
				html div
    				class: 'clear'.
				].! !

WAComponent subclass: #OcMenuComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcMenuComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 15:49'!
renderContentOn: html
	html heading: 'Menu'.
	html break.
	
	html anchor
  		callback: [];
  		with: 'Menu entry1'.
	html break.
	html anchor
  		callback: [];
  		with: 'Menu entry2'.
	html break.
	html anchor
  		callback: [];
  		with: 'Menu entry3'.
	! !

WAComponent subclass: #OcMessageComponent
	instanceVariableNames: 'messageString messageType wasShown'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcMessageComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:27'!
errorMessage: aString

	self
  		messageString: aString;
  		messageType: 'error';
  		wasShown: false.! !

!OcMessageComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:27'!
infoMessage: aString

	self
  		messageString: aString;
  		messageType: 'info';
  		wasShown: false.! !

!OcMessageComponent methodsFor: 'initialization' stamp: 'cmb 6/25/2013 21:26'!
initialize

	super initialize.
 	self wasShown: true.! !

!OcMessageComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:26'!
messageString
	^ messageString! !

!OcMessageComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:26'!
messageString: anObject
	messageString := anObject! !

!OcMessageComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:26'!
messageType
	^ messageType! !

!OcMessageComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:26'!
messageType: anObject
	messageType := anObject! !

!OcMessageComponent methodsFor: 'rendering' stamp: 'cmb 6/25/2013 21:27'!
renderContentOn: html

	self wasShown ifTrue: [^ self].
 	html div
  		class: self messageType, 'Message';
  		with: self messageString.
 	self wasShown: true.! !

!OcMessageComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:26'!
wasShown
	^ wasShown! !

!OcMessageComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:26'!
wasShown: anObject
	wasShown := anObject! !

WAComponent subclass: #OcRegisterComponent
	instanceVariableNames: 'user repeatedPassword messageComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 11:36'!
emailIsValid: anEmail
	^anEmail includesSubString: '@'.
  ! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:52'!
initialize 
	
	super initialize.
	self user: OcUser new.	
	self messageComponent: OcMessageComponent new.  ! !

!OcRegisterComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:32'!
messageComponent
	^ messageComponent! !

!OcRegisterComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:32'!
messageComponent: anObject
	messageComponent := anObject! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 14:32'!
registerUser

	self user userName isEmptyOrNil
  		ifTrue: [^ self messageComponent 
   		infoMessage: 'Please choose a username!!'].
	(self session findUserByUserName: self user userName)
		ifNotNil: [^ self messageComponent 
   		errorMessage: 'The username is already in use!!'].
	(self userNameIsValid: self user userName)
  		ifFalse: [^ self messageComponent 
   		errorMessage: 'Invalid username (invalid character @).'].
 	self user email isEmptyOrNil
  		ifTrue: [^ self messageComponent 
   		infoMessage: 'Please enter your e-mail address!!'].
	(self emailIsValid: self user email) 
  		ifFalse: [^ self messageComponent 
   		infoMessage: 'This e-mail address is not valid'].
 	(self session findUserByEmail: self user email)
  		ifNotNil: [^ self messageComponent 
   		errorMessage: 'The e-mail address is already registered!!'].
 	self user password = 0
  		ifTrue: [^ self messageComponent 
   		infoMessage: 'Please choose a password!!'].
 	self user password = self repeatedPassword
  		ifFalse: [^ self messageComponent 
   		infoMessage: 'Your repeated password does not match!!'].
 	self session database addUser: self user.
 	self answer: self user.! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:20'!
renderCancelButtonOn: html
 
	html submitButton
  		callback: [self answer: nil];
  		text: 'Cancel'.! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 23:21'!
renderContentOn: html

	html div
  		class: 'generic';
  		with: [
   		html
    			heading: 'Register an account';
    			render: self messageComponent;
    			form: [
     				html table: [
      				self
       					renderUsernameTextInputOn: html;
       					renderEmailTextInputOn: html;
       					renderPasswordTextInputOn: html;
       					renderRepeatedPasswordTextInputOn: html.
      				html tableRow: [
       					html
        						tableData;
        						tableData: [
         						self renderSubmitButtonOn: html.
         						html space.
         						self renderCancelButtonOn: html]]]]].! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:21'!
renderEmailTextInputOn: html

	html tableRow: [
  		html
   		tableData: 'E-mail';
   		tableData: [
    			html textInput
     				callback: [:value | self user email: value];
     				value: self user email]].! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:35'!
renderPasswordTextInputOn: html

	html tableRow: [
  		html
   		tableData: 'Password';
   		tableData: [
    			html passwordInput
     				callback: [:value | self user password: (OcUser hashPassword: value)]]].! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:35'!
renderRepeatedPasswordTextInputOn: html

	html tableRow: [
  		html
   		tableData: 'Repeat password';
   		tableData: [
    			html passwordInput
     				callback: [:value | self repeatedPassword: (OcUser hashPassword: value)]]].! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:59'!
renderSubmitButtonOn: html

	html submitButton
  		callback: [self registerUser];
  		text: 'Register'.! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:21'!
renderUsernameTextInputOn: html

	html tableRow: [
  		html
  		tableData: 'Username';
  		tableData: [
   		html textInput
    			callback: [:value | self user userName: value];
    			value: self user userName]].! !

!OcRegisterComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:18'!
repeatedPassword
	^ repeatedPassword! !

!OcRegisterComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:18'!
repeatedPassword: anObject
	repeatedPassword := anObject! !

!OcRegisterComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:18'!
user
	^ user! !

!OcRegisterComponent methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:18'!
user: anObject
	user := anObject! !

!OcRegisterComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 14:27'!
userNameIsValid: anUserName
	^(anUserName includesSubString: '@') not.
  ! !

WAComponent subclass: #OcWorkspaceComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcWorkspaceComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 15:08'!
renderContentOn: html
	html heading: 'Workspace'.
	html break.
	html anchor
  		callback: [];
  		with: 'Material1'.
	html break.
	html anchor
  		callback: [];
  		with: 'Material2'.
	html break.
	html anchor
  		callback: [];
  		with: 'Material3'.! !

!OcWorkspaceComponent methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 15:41'!
renderMaterial: aMaterial asRowOn: html

	html tableData: [html
  		tableData: aMaterial creationDate asString;
  		tableData: aMaterial title;
  		tableData: aMaterial owner;
  		tableData: aMaterial materialDescription].! !

WATask subclass: #OcRootTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcRootTask class methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:08'!
canBeRoot 
	^ true.! !

!OcRootTask methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 15:37'!
go

	| loginAnswer user |
 	loginAnswer := self call: OcLoginComponent new.
 	loginAnswer = #registerUser
  		ifTrue: [user := self call: OcRegisterComponent new]
  		ifFalse: [user := loginAnswer].
 	user ifNotNil: [
  		self session login: user.
  		self call: OcMainComponent new].! !

WAFileLibrary subclass: #OcLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcLibrary class methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:09'!
applicationName

	^ 'OpenCourses'! !

!OcLibrary methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 15:31'!
openCoursesCss

	^ '
body {
	font: normal 100% Arial, Helvetica, Verdana, sans-serif;
}
 
.generic {
	font-family: Geneva, Arial, Helvetica, sans-serif;
 	font-style: normal;
	font-weight: normal;
 	font-size: 14px;
	text-align: center;
 	color : #663300;
	background: #AAAAFF;
 	padding: 20px;
 	margin-top: 20px;
 	margin-left: auto;
	margin-right: auto;
 	border: 1px solid #663300;
 	width: 75%;
	height: auto;
}

.lightbox {
	background-color:#FFFFFF;
}

.errorMessage {
	background-color: #ffb0b0;
 	border: 1px solid #ee0000;
 	padding: 5px;
 	margin-bottom: 10px;
}

.infoMessage {
	background-color: #fbffcc;
 	border: 1px solid #eda33a;
 	padding: 5px;
 	margin-bottom: 10px;
}

.copyright {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-size: 10px;
 	font-style: normal;
 	font-weight: normal;
 	color: #663300;
 	text-align: left;
 	margin-left: 20px;
}

.menu {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-size: 10px;
 	font-style: normal;
 	font-weight: normal;
 	color: #663300;
	background: #FFAAAA;
 	text-align: center;
 	margin: auto;
	width: 20%;
	height: 100%;
	float: left;
}

.list {
	font-family: Geneva, Arial, Helvetica, sans-serif;
	font-size: 14px;
 	font-style: normal;
 	font-weight: normal;
 	color: #663300;
	background: #AAFFAA;
 	text-align: center;
	float: right;
	margin: auto;
	width: 80%;
	height: 100%;
}

.clear {
	clear: both;
	height: 1px;
	overflow: hidden;
	font-size:0pt;
	margin-top: -1px;
}

a {
	color : #663300;
 	text-decoration: underline;
}'! !

!OcLibrary methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:10'!
selectorsToInclude

	^ #( openCoursesCss )! !

Object subclass: #Data
	instanceVariableNames: ''
	classVariableNames: 'Admin MaterialList UserList'
	poolDictionaries: ''
	category: 'OpenCourses'!

!Data class methodsFor: 'accessing' stamp: 'Su 5/13/2013 15:41'!
admin
	^Admin! !

!Data class methodsFor: 'accessing' stamp: 'Su 5/13/2013 15:41'!
admin: aUser
	Admin := aUser! !

!Data class methodsFor: 'accessing' stamp: 'jsa 5/13/2013 19:50'!
blankData
	UserList := Set new.
	MaterialList := Set new.
	Admin := nil.! !

!Data class methodsFor: 'accessing' stamp: 'jsa 5/11/2013 18:19'!
materialList
	^ MaterialList! !

!Data class methodsFor: 'accessing' stamp: 'jsa 5/11/2013 18:19'!
materialList: aMaterialList
	MaterialList := aMaterialList! !

!Data class methodsFor: 'accessing' stamp: 'jsa 5/11/2013 18:19'!
userList
	^ UserList! !

!Data class methodsFor: 'accessing' stamp: 'jsa 5/11/2013 18:19'!
userList: aUserList
	UserList := aUserList! !

!Data methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 15:07'!
renderContentOn: html
	
	  ! !

Object subclass: #DidacticMaterial
	instanceVariableNames: 'file url title authors owner licence creationDate lastUploadDate type tags materialDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!DidacticMaterial methodsFor: 'comparing' stamp: 'jsa 5/12/2013 16:57'!
= aDidacticMaterial
	aDidacticMaterial ifNotNil: [^ aDidacticMaterial url = self url].
	^ false! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
authors
	"Answer the value of authors"

	^ authors! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
creationDate
	"Answer the value of creationDate"

	^ creationDate! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
creationDate: anObject
	"Set the value of creationDate"

	creationDate := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
file
	"Answer the value of file"

	^ file! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
file: anObject
	"Set the value of file"

	file := anObject! !

!DidacticMaterial methodsFor: 'comparing' stamp: 'jsa 5/12/2013 16:58'!
hash
	^ self url hash! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
lastUploadDate
	"Answer the value of lastUploadDate"

	^ lastUploadDate! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
lastUploadDate: anObject
	"Set the value of lastUploadDate"

	lastUploadDate := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
licence
	"Answer the value of licence"

	^ licence! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
licence: anObject
	"Set the value of licence"

	licence := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:31'!
materialDescription
	"Answer the value of description"

	^ materialDescription! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:31'!
materialDescription: anObject
	"Set the value of description"

	materialDescription := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
owner
	"Answer the value of owner"

	^ owner! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
owner: anObject
	"Set the value of owner"

	owner := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
tags
	"Answer the value of tags"

	^ tags! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
tags: anObject
	"Set the value of tags"

	tags := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
title
	"Answer the value of title"

	^ title! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
title: anObject
	"Set the value of title"

	title := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
type
	"Answer the value of type"

	^ type! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/11/2013 17:12'!
type: anObject
	"Set the value of type"

	type := anObject! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/12/2013 16:40'!
url
	"Answer the value of url"

	^ url! !

!DidacticMaterial methodsFor: 'accessing' stamp: 'jsa 5/12/2013 16:40'!
url: anObject
	"Set the value of url"

	url := anObject! !

Object subclass: #DidacticMaterialSearchSpecs
	instanceVariableNames: 'title description authors owner licence creationDateStart creationDateEnd lastUploadDateStart lastUploadDateEnd type tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
authors
	"Answer the value of authors"

	^ authors! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
creationDateEnd
	"Answer the value of creationDateEnd"

	^ creationDateEnd! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
creationDateEnd: anObject
	"Set the value of creationDateEnd"

	creationDateEnd := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
creationDateStart
	"Answer the value of creationDateStart"

	^ creationDateStart! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
creationDateStart: anObject
	"Set the value of creationDateStart"

	creationDateStart := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
description
	"Answer the value of description"

	^ description! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
description: anObject
	"Set the value of description"

	description := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
lastUploadDateEnd
	"Answer the value of lastUploadDateEnd"

	^ lastUploadDateEnd! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
lastUploadDateEnd: anObject
	"Set the value of lastUploadDateEnd"

	lastUploadDateEnd := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
lastUploadDateStart
	"Answer the value of lastUploadDateStart"

	^ lastUploadDateStart! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
lastUploadDateStart: anObject
	"Set the value of lastUploadDateStart"

	lastUploadDateStart := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
licence
	"Answer the value of licence"

	^ licence! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
licence: anObject
	"Set the value of licence"

	licence := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'comparing' stamp: 'Su 5/12/2013 23:31'!
matches: aDidacticMaterial
	self title ifNotNil: [aDidacticMaterial title = self title ifFalse: [^ false]].
	self creationDateStart ifNotNil: [aDidacticMaterial creationDate > self creationDateStart ifFalse: [^ false]].
	self creationDateEnd ifNotNil: [aDidacticMaterial creationDate < self creationDateEnd ifFalse: [^ false]].
	self lastUploadDateStart ifNotNil: [aDidacticMaterial lastUploadDate > self lastUploadDateStart ifFalse: [^ false]].
	self lastUploadDateEnd ifNotNil: [aDidacticMaterial lastUploadDate < self lastUploadDateEnd ifFalse: [^ false]].
	self description ifNotNil: [aDidacticMaterial description = self description ifFalse: [^ false]].
	self owner ifNotNil: [aDidacticMaterial owner email = self owner ifFalse: [^ false]].
	self authors ifNotNil: [((aDidacticMaterial authors) includesAnyOf: (self authors)) ifFalse: [^ false]].
	self licence ifNotNil: [aDidacticMaterial licence = self licence ifFalse: [^false]].
	self type ifNotNil: [aDidacticMaterial type = self type ifFalse: [^ false]].
	self tags ifNotNil: [ ((aDidacticMaterial tags) includesAnyOf: (self tags)) ifFalse: [^ false]].
	^true! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
owner
	"Answer the value of owner"

	^ owner! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
owner: anObject
	"Set the value of owner"

	owner := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
tags
	"Answer the value of tags"

	^ tags! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
tags: anObject
	"Set the value of tags"

	tags := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
title
	"Answer the value of title"

	^ title! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
title: anObject
	"Set the value of title"

	title := anObject! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
type
	"Answer the value of type"

	^ type! !

!DidacticMaterialSearchSpecs methodsFor: 'accessing' stamp: 'jsa 5/11/2013 19:34'!
type: anObject
	"Set the value of type"

	type := anObject! !

Object subclass: #FakeFile
	instanceVariableNames: 'title contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
contents
	"Answer the value of contents"

	^ contents! !

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
contents: anObject
	"Set the value of contents"

	contents := anObject! !

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
title
	"Answer the value of title"

	^ title! !

!FakeFile methodsFor: 'accessing' stamp: 'jsa 5/11/2013 16:50'!
title: anObject
	"Set the value of title"

	title := anObject! !

Object subclass: #MaterialManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!MaterialManager methodsFor: 'private' stamp: 'Su 5/12/2013 21:55'!
createMaterialURL: aMaterial
	| numberOfMaterialsWithSameAuthorAndTitle|
	 numberOfMaterialsWithSameAuthorAndTitle := (Data materialList select: [ : material | material owner = aMaterial owner and: material title = aMaterial title]) size.
	^aMaterial owner email, '/', aMaterial title, ((numberOfMaterialsWithSameAuthorAndTitle = 0) ifTrue:[''] ifFalse:['_', numberOfMaterialsWithSameAuthorAndTitle]).
	! !

!MaterialManager methodsFor: 'management' stamp: 'jsa 5/13/2013 15:18'!
editMaterial: anEditedMaterial
	| materialToEdit |
	materialToEdit := Data materialList like: anEditedMaterial.
	materialToEdit ifNotNil: [
		(UserManager new canEditMaterial: materialToEdit owner)
			ifFalse: [Error signal: 'User doesn''t have permission to edit this material'].
	
		anEditedMaterial title ifNotNil: [materialToEdit title: anEditedMaterial title].
		anEditedMaterial description ifNotNil: [materialToEdit description: anEditedMaterial description].
		anEditedMaterial authors ifNotNil: [materialToEdit authors: anEditedMaterial authors].
		anEditedMaterial file ifNotNil: [materialToEdit file: anEditedMaterial file].
		anEditedMaterial tags ifNotNil: [materialToEdit tags: anEditedMaterial tags].
		anEditedMaterial type ifNotNil: [materialToEdit type: anEditedMaterial type].
		anEditedMaterial licence ifNotNil: [materialToEdit licence: anEditedMaterial licence].
	]! !

!MaterialManager methodsFor: 'private' stamp: 'jsa 5/11/2013 18:21'!
materialList
	^ Data materialList! !

!MaterialManager methodsFor: 'management' stamp: 'jsa 5/13/2013 15:14'!
removeMaterial: aUrl
	| materialToRemove |
	materialToRemove := Data materialList like: (DidacticMaterial new url: aUrl).
	(UserManager new canRemoveMaterial: materialToRemove owner)
		ifFalse: [Error signal: 'User doesn''t have permission to remove this material'].
	Data materialList remove: materialToRemove.! !

!MaterialManager methodsFor: 'searching' stamp: 'jsa 5/11/2013 19:35'!
search: aDidacticMaterialSearchSpecs
	^ Data materialList select: [ :material | aDidacticMaterialSearchSpecs matches: material]! !

!MaterialManager methodsFor: 'management' stamp: 'Su 5/12/2013 21:42'!
submitMaterial: submittedFile title: title authors: authorsList description: description type: type licence: licence tags: tags
	| material now user|
	now := TimeStamp now.
	user := Session user.
	UserManager new canSubmitMaterial ifTrue: [
	material := DidacticMaterial new file: submittedFile; title: title; authors: authorsList; description: description; type: type; licence: licence; tags: tags; creationDate: now; lastUploadDate: now; owner: user.
	material url: (self createMaterialURL: material).
	Data materialList add: material]
	ifFalse: [Error signal: 'User doesn''t have permission to submit material']! !

Object subclass: #OcDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:14'!
connect

	^ true! !

!OcDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:14'!
connectionFailed

	^ false! !

!OcDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:14'!
disconnect

	^ true! !

OcDatabase subclass: #OcImageDatabase
	instanceVariableNames: ''
	classVariableNames: 'Users WriteMutex'
	poolDictionaries: ''
	category: 'OpenCourses'!

OcImageDatabase class
	instanceVariableNames: 'Users'!

OcImageDatabase class
	instanceVariableNames: 'Users'!

!OcImageDatabase class methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:45'!
users
	^ Users ifNil: [Users := OrderedCollection new]! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:44'!
users: anObject
	Users := anObject! !

!OcImageDatabase class methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 23:04'!
writeMutex
 
	^ WriteMutex ifNil: [WriteMutex := Monitor new]! !

!OcImageDatabase class methodsFor: 'accessing' stamp: 'cmb 6/25/2013 23:04'!
writeMutex: anObject
	WriteMutex := anObject! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:22'!
addUser: aUser

	self class users add: aUser.
 	self saveImage.
 	^ aUser! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:22'!
findUserByEmail: anEmail

	^ self class users
  		detect: [:each | each email = anEmail]
  		ifNone: [nil]! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 10:20'!
findUserByUserName: anUserName

	^ self class users
  		detect: [:each | each userName = anUserName]
  		ifNone: [nil]! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:21'!
saveImage

	self class writeMutex critical: [self saveImageWithoutMonitor]! !

!OcImageDatabase methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:19'!
saveImageWithoutMonitor

	SmalltalkImage current saveSession.! !

Object subclass: #OcDidacticMaterial
	instanceVariableNames: 'file url title authors owner licence creationDate lastUploadDate type tags materialDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcDidacticMaterial methodsFor: 'comparing' stamp: 'cmb 6/28/2013 14:33'!
= aDidacticMaterial
	aDidacticMaterial ifNotNil: [^ aDidacticMaterial url = self url].
	^ false! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
authors
	"Answer the value of authors"

	^ authors! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
authors: anObject
	"Set the value of authors"

	authors := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
creationDate
	"Answer the value of creationDate"

	^ creationDate! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
creationDate: anObject
	"Set the value of creationDate"

	creationDate := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
file
	"Answer the value of file"

	^ file! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
file: anObject
	"Set the value of file"

	file := anObject! !

!OcDidacticMaterial methodsFor: 'comparing' stamp: 'cmb 6/28/2013 14:33'!
hash
	^ self url hash! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
lastUploadDate
	"Answer the value of lastUploadDate"

	^ lastUploadDate! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
lastUploadDate: anObject
	"Set the value of lastUploadDate"

	lastUploadDate := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
licence
	"Answer the value of licence"

	^ licence! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
licence: anObject
	"Set the value of licence"

	licence := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
materialDescription
	"Answer the value of description"

	^ materialDescription! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
materialDescription: anObject
	"Set the value of description"

	materialDescription := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
owner
	"Answer the value of owner"

	^ owner! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
owner: anObject
	"Set the value of owner"

	owner := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
tags
	"Answer the value of tags"

	^ tags! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
tags: anObject
	"Set the value of tags"

	tags := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
title
	"Answer the value of title"

	^ title! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
title: anObject
	"Set the value of title"

	title := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
type
	"Answer the value of type"

	^ type! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
type: anObject
	"Set the value of type"

	type := anObject! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
url
	"Answer the value of url"

	^ url! !

!OcDidacticMaterial methodsFor: 'accessing' stamp: 'cmb 6/28/2013 14:33'!
url: anObject
	"Set the value of url"

	url := anObject! !

Object subclass: #OcUser
	instanceVariableNames: 'id password email userName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcUser class methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 23:36'!
hashPassword: aString

	^ aString 
  		ifEmpty: [0] 
  		ifNotEmpty: [GRPlatform current secureHashFor: aString].! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
email
	"Answer the value of email"

	^ email! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
email: anObject
	"Set the value of email"

	email := anObject! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:34'!
id
	^ id! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:34'!
id: anObject
	id := anObject! !

!OcUser methodsFor: 'checking' stamp: 'cmb 5/13/2013 00:13'!
isLogged
	^ Session user = self.! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
password
	"Answer the value of password"

	^ password! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 5/10/2013 16:30'!
password: anObject
	"Set the value of password"

	password := anObject! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:35'!
userName
	"Answer the value of name"
	^ userName! !

!OcUser methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:35'!
userName: anObject
	"Set the value of name"

	userName := anObject! !

Object subclass: #Session
	instanceVariableNames: ''
	classVariableNames: 'CurrentUser'
	poolDictionaries: ''
	category: 'OpenCourses'!

!Session class methodsFor: 'accessing' stamp: 'cmb 5/10/2013 18:58'!
user
	^CurrentUser! !

!Session class methodsFor: 'accessing' stamp: 'cmb 5/10/2013 18:58'!
user: aUser
	CurrentUser := aUser! !

Object subclass: #UserManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!UserManager methodsFor: 'permission' stamp: 'Su 5/13/2013 16:48'!
canChangeUserEmail: anUser
	Session user ifNotNil:
		[^ (Session user = anUser) or: (Session user = Data admin)].
	^ false
	! !

!UserManager methodsFor: 'permission' stamp: 'jsa 5/13/2013 17:51'!
canChangeUserName: anUser
	Session user ifNotNil:
		[^ (Session user = anUser) or: (Session user = Data admin)].
	^ false
	! !

!UserManager methodsFor: 'permission' stamp: 'Su 5/13/2013 17:44'!
canChangeUserPassword: anUser
	Session user ifNotNil:
		[^ (Session user = anUser) or: (Session user = Data admin)].
	^ false
	! !

!UserManager methodsFor: 'permission' stamp: 'Su 5/13/2013 16:24'!
canEditMaterial: userOwner
	Session user ifNotNil:
		[^ (Session user = userOwner) or: (Session user = Data admin)].
	^ false
	! !

!UserManager methodsFor: 'permission' stamp: 'Su 5/13/2013 16:24'!
canRemoveMaterial: userOwner
	Session user ifNotNil:
		[^ Session user = userOwner or: (Session user = Data admin)].
	^ false
	! !

!UserManager methodsFor: 'permission' stamp: 'jsa 5/13/2013 19:25'!
canRemoveUser: userToRemove
	Session user ifNotNil:
		[^ Session user = userToRemove or: (Session user = Data admin)].
	^ false
	! !

!UserManager methodsFor: 'permission' stamp: 'jsa 5/11/2013 18:44'!
canSubmitMaterial
	^ (Session user isNil) not! !

!UserManager methodsFor: 'editing' stamp: 'cmb 6/25/2013 21:35'!
changeEmail: user newEmail: newEmail
	(Data userList includes: (OcUser new email: newEmail))
		ifTrue: [Error signal: 'email already used by another user.']
		ifFalse: [
			(self canChangeUserEmail: user) ifTrue: [
				self registerNewUser: user name password: user password email: newEmail.
				Data userList remove: user.
				(Session user = user) ifTrue: [
				Session user: (Data userList like: (OcUser new email: newEmail)).
				]] ifFalse: [Error signal: 'User doesn''t have permission to change this email.']]
		


! !

!UserManager methodsFor: 'editing' stamp: 'jsa 5/13/2013 17:51'!
changeName: anUser newName: newName
	| registeredUser |
	(self canChangeUserName: anUser) ifTrue: [
		registeredUser := Data userList like: anUser.
		registeredUser name: newName.
	] ifFalse: [
		Error signal: 'User doesn''t have permission to change this name.'
	]
		! !

!UserManager methodsFor: 'editing' stamp: 'Su 5/13/2013 17:44'!
changePassword: anUser newPassword: newPassword
	(self canChangeUserPassword: anUser) ifTrue: [
		anUser password: newPassword.
		] 
	ifFalse: [
		Error signal: 'User doesn''t have permission to change this password.'
		]
		! !

!UserManager methodsFor: 'private' stamp: 'jsa 5/11/2013 18:21'!
hasUser: aUser 
	^ Data userList includes: aUser! !

!UserManager methodsFor: 'authentication' stamp: 'cmb 6/25/2013 21:35'!
login: email password: password 
	| user registeredUser | 
	Data admin ifNil: [(email = 'admin' and: password = 'admin') ifTrue: [self registerDefaultAdmin]].
	user := OcUser new email: email;
				 password: password.
	registeredUser := Data userList
				like: user
				ifAbsent: [Error signal: 'User/Password incorrect!!'].
	user password = registeredUser password
		ifTrue: [Session user: registeredUser]
		ifFalse: [Error signal: 'User/Password incorrect!!']! !

!UserManager methodsFor: 'authentication' stamp: 'cmb 5/13/2013 19:22'!
logoff
	Session user: nil.! !

!UserManager methodsFor: 'managing' stamp: 'cmb 6/25/2013 21:35'!
registerDefaultAdmin
	self registerNewUser: 'admin' password: 'admin' email: 'admin'.
	Data admin: (Data userList like: (OcUser new email: 'admin')). ! !

!UserManager methodsFor: 'managing' stamp: 'cmb 6/25/2013 21:35'!
registerNewUser: name password: password email: email 
	| newUser |
	newUser := OcUser new name: name;
				 password: password;
				 email: email.
	(Data userList includes: newUser)
		ifFalse: [Data userList add: newUser]
		ifTrue: [Error signal: 'Duplicated user']! !

!UserManager methodsFor: 'managing' stamp: 'jsa 5/13/2013 19:26'!
removeUser: anUser
	| userToRemove |
	userToRemove := Data userList like: anUser.
	(UserManager new canRemoveUser: userToRemove)
		ifFalse: [Error signal: 'User doesn''t have permission to remove this user'].
	Data userList remove: userToRemove.
	(Session user = anUser) ifTrue: [
		self logoff
	]! !

!UserManager methodsFor: 'private' stamp: 'Su 5/13/2013 16:21'!
userList
	"Answer the value of userList"

	^Data userList! !

TestCase subclass: #MaterialManagerTest
	instanceVariableNames: 'emptyMaterialList nonEmptyMaterialList materialManager authorsList submittedFile tags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Tests'!

!MaterialManagerTest methodsFor: 'running' stamp: 'cmb 6/25/2013 21:35'!
setUp
      Data blankData.
	emptyMaterialList := Data materialList copy.
	materialManager := MaterialManager new.
	Session user: (OcUser new email: 'auser@email.com').
	authorsList := OrderedCollection new.
	authorsList add: 'an author1'; add: 'an author2'; add: 'an author3'.
	submittedFile := FakeFile new title: 'a file title'; contents: (ByteArray new).
	tags := SortedCollection new.
	tags add: 'DNA'; add: 'RNA'; add:'Molecular Biology'.
	materialManager submitMaterial: submittedFile title: 'a title' authors: authorsList description: 'a description' type: 'class note' licence: 'GPLv3' tags: tags.
	Session user: (OcUser new email: 'user@email.com').
	authorsList := OrderedCollection new.
	authorsList add: 'author1'; add: 'author2'.
	submittedFile := FakeFile new title: 'file title'; contents: (ByteArray new).
	tags := SortedCollection new.
	tags add: 'OOP'; add: 'Smalltalk'.
	materialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags.
	nonEmptyMaterialList := Data materialList copy! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 5/12/2013 18:44'!
testEditMaterialEverythingButTitle
	| newAuthorsList newSubmittedFile newTags |
	Data materialList: nonEmptyMaterialList.
	newAuthorsList := OrderedCollection new add: 'new'; add: 'authors'.
	newSubmittedFile := FakeFile new title: 'new file title'; contents: (ByteArray new).
	newTags := SortedCollection new add: 'new'; add: 'tags'.
	self assert: (materialManager materialList select: [ :material | (material title = 'title'
		and: material description = 'new description'
		and: material authors = newAuthorsList)
		and: material file title = newSubmittedFile title
		and: material tags = newTags
		and: material type = 'code'
		and: material licence = 'GPLv2']) size == 0.
	self assert: (materialManager materialList select: [ :material | material title = 'title' and: material description = 'description']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | materialManager editMaterial: (DidacticMaterial new url: material url; description: 'new description';
			authors: newAuthorsList; file: newSubmittedFile; tags: newTags; type: 'code'; licence: 'GPLv2')].
	self assert: (materialManager materialList select: [ :material | material title = 'title' and: material description = 'description']) size == 0.
		self assert: (materialManager materialList select: [ :material | (material title = 'title'
		and: material description = 'new description'
		and: material authors = newAuthorsList)
		and: material file title = newSubmittedFile title
		and: material tags = newTags
		and: material type = 'code'
		and: material licence = 'GPLv2']) size == 1.! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 5/13/2013 19:41'!
testEditMaterialLoggedAsAdmin
	UserManager new login: 'admin' password: 'admin'.
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | materialManager editMaterial: (DidacticMaterial new url: material url; title: 'new title')].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 0.
	self assert: (materialManager materialList select: [ :material | material title = 'new title']) size == 1.! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'cmb 6/25/2013 21:35'!
testEditMaterialLoggedAsDifferentUser
	Session user: (OcUser new email: 'another_user@somewhere_over_the_rainbow.com').
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | self should: [materialManager editMaterial: (DidacticMaterial new url: material url; title: 'new title')] raise: Error].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	self assert: (materialManager materialList select: [ :material | material title = 'new title']) size == 0.! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 5/12/2013 18:33'!
testEditMaterialTitle
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'new title']) size == 0.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | materialManager editMaterial: (DidacticMaterial new url: material url; title: 'new title')].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 0.
	self assert: (materialManager materialList select: [ :material | material title = 'new title' and: material description = 'description']) size == 1.! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 5/13/2013 14:31'!
testEditMaterialTitleThatDoesntExist
	| numberOfMaterials |
	Data materialList: nonEmptyMaterialList.
	numberOfMaterials := materialManager materialList size.
	self assert: (materialManager materialList select: [ :material | material url = 'inexistent url']) size == 0.
	materialManager editMaterial: (DidacticMaterial new url: 'inexistent url').
	self assert: materialManager materialList size = numberOfMaterials.! !

!MaterialManagerTest methodsFor: 'editing' stamp: 'jsa 5/12/2013 18:52'!
testEditMaterialWithoutLogin
	Data materialList: nonEmptyMaterialList.
	Session user: nil.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | self should: [materialManager editMaterial: (DidacticMaterial new url: material url; title: 'new title')] raise: Error].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	self assert: (materialManager materialList select: [ :material | material title = 'new title']) size == 0.! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'jsa 5/12/2013 16:52'!
testRemoveMaterial
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | materialManager removeMaterial: material url].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 0.! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'jsa 5/13/2013 19:48'!
testRemoveMaterialLoggedAsAdmin
	UserManager new login: 'admin' password: 'admin'.
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | materialManager removeMaterial: material url].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 0.! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'cmb 6/25/2013 21:35'!
testRemoveMaterialLoggedAsDifferentUser
	Session user: (OcUser new email: 'another_user@somewhere_over_the_rainbow.com').
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | self should: [materialManager removeMaterial: material url] raise: Error].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'jsa 5/13/2013 14:26'!
testRemoveMaterialThatDoesntExist
	| numberOfMaterials |
	Data materialList: nonEmptyMaterialList.
	numberOfMaterials := materialManager materialList size.
	self assert: (materialManager materialList select: [ :material | material title = 'inexistent title']) size == 0.
	(materialManager materialList select: [ :material | material title = 'inexistent title'])
		do: [ :material | materialManager removeMaterial: material url].
	self assert: materialManager materialList size = numberOfMaterials.! !

!MaterialManagerTest methodsFor: 'removing' stamp: 'jsa 5/12/2013 17:01'!
testRemoveMaterialWithoutLogin
	Session user: nil.
	Data materialList: nonEmptyMaterialList.
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.
	(materialManager materialList select: [ :material | material title = 'title'])
		do: [ :material | self should: [materialManager removeMaterial: material url] raise: Error].
	self assert: (materialManager materialList select: [ :material | material title = 'title']) size == 1.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 23:44'!
testSearchByAuthors
	| searchSpecsNoResult searchSpecsWithResult|
	Data materialList: nonEmptyMaterialList.
	authorsList := OrderedCollection new.
	authorsList add: 'wrong author'.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new authors: authorsList. 
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	authorsList add: 'author1'.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new authors: authorsList. 
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	authorsList add: 'author2'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	authorsList add: 'an author3'.
	self assert: (materialManager search: searchSpecsWithResult) size == 2.
	! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 18:42'!
testSearchByCreationDate
	| searchSpecsNoResult searchSpecsWithResult |
	nonEmptyMaterialList := Data materialList copy.
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new creationDateStart: (TimeStamp now plusSeconds: 4); creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new creationDateStart: (TimeStamp now minusSeconds: 14); creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 2.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 22:46'!
testSearchByDescription
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new description:  'wrong description'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new description: 'description'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 22:01'!
testSearchByLastUploadDate
	| searchSpecsNoResult searchSpecsWithResult |
	nonEmptyMaterialList := Data materialList copy.
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new lastUploadDateStart: (TimeStamp now plusSeconds: 4); lastUploadDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new lastUploadDateStart: (TimeStamp now minusSeconds: 14); lastUploadDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 2.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 22:56'!
testSearchByLicence
	| searchSpecsNoResult searchSpecsWithResult |
	nonEmptyMaterialList add: (DidacticMaterial new licence: 'none').
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new licence:  'wrong licence'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new licence: 'none'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new licence: 'GPLv3'.
	self assert: (materialManager search: searchSpecsWithResult) size == 2.
	
	! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 22:08'!
testSearchByOwner
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new owner:  'wrong_owner@email.com'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new owner: 'user@email.com'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 23:45'!
testSearchByTags
	| searchSpecsNoResult searchSpecsWithResult|
	Data materialList: nonEmptyMaterialList.
	tags := SortedCollection new.
	authorsList add: 'wrong tag'.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new tags: tags. 
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	tags := OrderedCollection new. 
	tags add: 'OOP'.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new tags: tags. 
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	authorsList add: 'Smalltalk'.
      searchSpecsWithResult := DidacticMaterialSearchSpecs new tags: tags.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.
	tags add: 'DNA'.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new tags: tags.
	self assert: (materialManager search: searchSpecsWithResult) size == 2.
	! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'jsa 5/11/2013 19:34'!
testSearchByTitle
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new title: 'wrong title'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new title: 'title'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'jsa 5/11/2013 19:43'!
testSearchByTitleAndCreationDate
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new title: 'title'; creationDateStart: (TimeStamp now plusSeconds: 4); creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new title: 'title'; creationDateStart: (TimeStamp now minusSeconds: 14); creationDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/12/2013 18:19'!
testSearchByTitleAndLastUploadDate
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new title: 'title'; lastUploadDateStart: (TimeStamp now plusSeconds: 4); lastUploadDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new title: 'title'; lastUploadDateStart: (TimeStamp now minusSeconds: 14); lastUploadDateEnd: (TimeStamp now plusSeconds: 10).
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'searching' stamp: 'Su 5/13/2013 00:04'!
testSearchByType
	| searchSpecsNoResult searchSpecsWithResult |
	Data materialList: nonEmptyMaterialList.
	searchSpecsNoResult := DidacticMaterialSearchSpecs new type: 'wrong type'.
	self assert: (materialManager search: searchSpecsNoResult) size == 0.
	searchSpecsWithResult := DidacticMaterialSearchSpecs new type: 'slide show'.
	self assert: (materialManager search: searchSpecsWithResult) size == 1.! !

!MaterialManagerTest methodsFor: 'submitting' stamp: 'Su 5/12/2013 21:40'!
testSubmitMaterial
	Data materialList: emptyMaterialList.
	materialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags.
	self assert: (materialManager materialList select: [:material | material title = 'title']) size == 1.! !

!MaterialManagerTest methodsFor: 'submitting' stamp: 'cmb 6/25/2013 21:35'!
testSubmitMaterialAutomaticFields
	| loggedUser now maxDuration|
	Data materialList: emptyMaterialList.
	loggedUser := OcUser new email: 'user@email.com'.
	Session user: loggedUser.
	maxDuration := Duration seconds: 1.
	now := TimeStamp now.
	materialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags.
	self assert: (materialManager materialList select: [:material | material owner = loggedUser and: material creationDate - now <  maxDuration and: material lastUploadDate - now < maxDuration]) size == 1.
	self assert: (materialManager materialList select: [:material | material url = 'user@email.com/title']) size == 1! !

!MaterialManagerTest methodsFor: 'submitting' stamp: 'jsa 5/11/2013 18:37'!
testSubmitMaterialWithoutLogin
	Data materialList: emptyMaterialList.
	Session user: nil.
	self should: [materialManager submitMaterial: submittedFile title: 'title' authors: authorsList description: 'description' type: 'slide show' licence: 'GPLv3' tags: tags] raise: Error.
	self assert: (materialManager materialList select: [:material | material title = 'title']) size == 0.! !

TestCase subclass: #UserManagerTest
	instanceVariableNames: 'emptyUserList nonEmptyUserList userManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses-Tests'!

!UserManagerTest methodsFor: 'running' stamp: 'Su 5/13/2013 17:08'!
setUp
	Data blankData.
	emptyUserList := Data userList copy.
	userManager := UserManager new.
	userManager registerNewUser: 'john' password: '123admin' email: 'johnadmin@me.com'.
	nonEmptyUserList := Data userList copy.
	userManager login: 'johnadmin@me.com' password: '123admin'.
	Data admin: nil.
	! !

!UserManagerTest methodsFor: 'testing' stamp: 'Su 5/13/2013 17:33'!
testChangeEmail
	| mockUser |
	"Deveria dar erro quando email j est cadastrado"
	self should: [userManager changeEmail: Session user newEmail:  Session user email] raise: Error.
	mockUser := Session user copy.
	userManager changeEmail: Session user newEmail: 'johnadmin@newemail.com'.
	self assert: [Session user email = 'johnadmin@newemail.com'].
	self assert: [Data userList includes: Session user].
	self shouldnt: [Data userList includes: mockUser]! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testChangeEmailLoggedAsAdmin
	| oldUser user |
	oldUser := Session user copy.
	user := Session user.
	userManager login: 'admin' password: 'admin'.
	"Deveria dar erro quando email j est cadastrado"
	self should: [userManager changeEmail: user newEmail:  user email] raise: Error.
	userManager changeEmail: user newEmail: 'johnadmin@newemail.com'.
	self assert: [Session user email = 'admin'].
	self assert: [Data userList includes: (OcUser new email: 'johnadmin@newemail.com')].
	self shouldnt: [Data userList includes: oldUser].
! !

!UserManagerTest methodsFor: 'testing' stamp: 'Su 5/13/2013 17:46'!
testChangeEmailWithoutLogin
	| oldUser |
	oldUser := Session user.
	Session user: nil.
	self should: [userManager changeEmail:  oldUser newEmail: 'blabla'] raise: Error
! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testChangeEmailWithoutPermission
	| oldUser |
	oldUser := Session user.
	Session user: (OcUser new email: 'another_user@email.com').
	self should: [userManager changeEmail:  oldUser newEmail: 'blabla'] raise: Error
! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 5/13/2013 17:40'!
testChangeName
	| newName |
	newName := 'new_name'.
	userManager changeName: Session user newName: newName.
	self assert: [Session user name = newName].
	self assert: [Data userList includes: Session user]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 5/13/2013 19:17'!
testChangeNameLoggedAsAdmin
	| user newName |
	user := Session user copy.
	userManager login: 'admin' password: 'admin'.
	newName := 'new_name'.
	userManager changeName: user newName: newName.
	self assert: [Session user email = 'admin'].
	self assert: [Data userList includes: user].
	self assert: [(Data userList select: [ :anUser | anUser = user and: anUser name = newName]) size = 1].! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testChangeNameWithoutPermission
	| oldUser |
	oldUser := Session user.
	Session user: (OcUser new email: 'another_user@email.com').
	self should: [userManager changeName: oldUser newName: 'blabla'] raise: Error! !

!UserManagerTest methodsFor: 'testing' stamp: 'Su 5/13/2013 17:21'!
testChangePassword
	| newPassword |
	newPassword := 'new_password'.
	userManager changePassword: Session user newPassword: newPassword.
	self assert: [Session user password = newPassword].
	self assert: [Data userList includes: Session user]
! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 5/13/2013 19:17'!
testChangePasswordLoggedAsAdmin
	| newPassword oldUser|
	newPassword := 'new_password'.
	oldUser := Session user.
      userManager login: 'admin' password:'admin'.
	userManager changePassword: oldUser newPassword: newPassword.
	self assert: [Session user email = 'admin'].
	self assert: [oldUser password = newPassword].
	self assert: [Data userList includes: oldUser]
! !

!UserManagerTest methodsFor: 'testing' stamp: 'Su 5/13/2013 17:56'!
testChangePasswordWithoutLogin
	| oldUser |
	oldUser := Session user.
	Session user: nil.
	self should: [userManager changePassword:  oldUser newPassword: 'new_password'] raise: Error.
	self assert: Session user isNil
! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testChangePasswordWithoutPermission
	| oldUser |
	oldUser := Session user.
	Session user: (OcUser new email: 'another_user@email.com').
	self should: [userManager changePassword:  oldUser newPassword: 'new_password'] raise: Error.
	self assert: (Session user email = 'another_user@email.com')
! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testFirstAdminLogin
	Data userList: emptyUserList.
	Data admin: nil.
	Session user: nil.
	self
		should: [userManager login: 'admin' password: 'admin'.
			Session user = Data admin and: (Data admin isNil) not 
			and: (userManager userList includes: (OcUser new email: 'admin'))].
	Session user: nil.
	self
		should: [userManager login: 'admin' password: 'admin'.
			Session user = Data admin and: (Data admin isNil) not 
			and: (userManager userList includes: (OcUser new email: 'admin'))]! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testLogin
	| loggedUser |
	Data userList: nonEmptyUserList.
	self
		should: [userManager login: 'emailDoesntExist' password: '123admin']
		raise: Error.
	self
		should: [userManager login: 'johnadmin@me.com' password: 'wrongPassword']
		raise: Error.
	loggedUser := OcUser new email: 'johnadmin@me.com'.
	self
		should: [userManager login: 'johnadmin@me.com' password: '123admin'.
			Session user = loggedUser]! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 5/13/2013 19:31'!
testLogoff
	(Session user == nil)
		ifFalse: [
			userManager logoff.
			self assert: [Session user == nil]
			].! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testRegisterNewUser
	| createdUser |
	createdUser := OcUser new name: 'john';
				 password: '123admin';
				 email: 'johnadmin@me.com'.
	Data userList: emptyUserList.
	self
		shouldnt: [userManager hasUser: createdUser].
	userManager
		registerNewUser: 'john'
		password: '123admin'
		email: 'johnadmin@me.com'.
	self
		assert: (userManager hasUser: createdUser)! !

!UserManagerTest methodsFor: 'testing' stamp: 'cmb 6/25/2013 21:35'!
testRemoveUser
	| listSize currentUser|
	currentUser := Session user.
	
	"try to remove an unexistent user"
	self should: [userManager removeUser: (OcUser new email: 'wrong@email.com')] raise: Error.
	
	"try to remove unlogged"
	Session user: nil.
	self should: [userManager removeUser: currentUser] raise: Error.
	
	"try to remove correct"
	Session user: currentUser.
	listSize := Data userList size.
	userManager removeUser: currentUser.
	self assert: [listSize > Data userList size].
	! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 5/13/2013 19:35'!
testRemoveUserLoggedAsAdmin
	| listSize currentUser|
	currentUser := Session user.
	userManager login: 'admin' password:'admin'.
	listSize := Data userList size.
	userManager removeUser: currentUser.
	self assert: [listSize > Data userList size].
	self assert: [Session user email = 'admin'].
	! !

!UserManagerTest methodsFor: 'testing' stamp: 'jsa 5/11/2013 18:31'!
testTryToRegisterAnAlreadyRegisteredUser
	Data userList: nonEmptyUserList.
	self
		should: [userManager
				registerNewUser: 'jon'
				password: '123admin321'
				email: 'johnadmin@me.com']
		raise: Error! !

WASession subclass: #OcSession
	instanceVariableNames: 'user database'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OpenCourses'!

!OcSession methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:26'!
database
	^ database! !

!OcSession methodsFor: 'accessing' stamp: 'cmb 6/25/2013 22:26'!
database: anObject
	database := anObject! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 11:07'!
findUser: anUserName email: anEmail
	
	| userByEmail userByUserName |
	userByEmail := self database findUserByEmail: anEmail.
	userByUserName := self database findUserByUserName: anUserName.
	userByEmail ifNil: [^userByUserName].
	^userByEmail.
		
	

	! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:27'!
findUserByEmail: anEmail

	^ self database findUserByEmail: anEmail! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/28/2013 10:15'!
findUserByUserName: anUserName

	^ self database findUserByUserName: anUserName! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:27'!
initialize
 
	super initialize.
	self database: OcImageDatabase new.! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:05'!
isLoggedIn 
	^ self user notNil.! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:03'!
login: aUser
	self user: aUser.  ! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 21:04'!
logout
	self user: nil.  ! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:28'!
responseForRequest: aRequest

	self database connectionFailed
  		ifTrue: [^ WAResponse new nextPutAll: 'No Database Connection'].
	^ super responseForRequest: aRequest! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:27'!
unregistered

	self database disconnect.
	super unregistered.! !

!OcSession methodsFor: 'as yet unclassified' stamp: 'cmb 6/25/2013 22:12'!
updateRoot: anHtmlRoot

	super updateRoot: anHtmlRoot.
 	anHtmlRoot title: OcLibrary applicationName.! !

!OcSession methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:02'!
user
	^ user! !

!OcSession methodsFor: 'accessing' stamp: 'cmb 6/25/2013 21:02'!
user: anObject
	user := anObject! !
